PAGE 60,132  ; STATE THE ROW AND COLUMN FORMAT FOR LISTING FILE

TITLE ***PROGRAM TO DO 32-BIT DIVISION***  ; PRINTS OUT TITLE FOR YOUR LISTING 

INCLUDE ..\MACROS\KB16H.MAC
INCLUDE ..\MACROS\KB21H.MAC

;-------------CONSTRUCT A STACK SEGMENT----------------

STSEG   SEGMENT STACK 'STACK'
        DB 64 DUP(?)     ; RESERVE 64-BYTES FOR STACK
STSEG 	ENDS

;--------------CONSTRUCT A DATA SEGMENT---------------- 

DTSEG   SEGMENT  ; DEFINE CONSTANTS (DON'T REQUIRE MEMORY)

   CR EQU 0DH ; DEFINING CR AS CARRIAGE RETURN CHARACTER
   LF EQU 0AH ; DEFINING LF AS LINE FEED CHARACTER

   ; ----- DEFINE MEMORY LOCATIONS TO STORE THE NUMERATOR AND DENOMINATOR -----
   NUMER DD 447886541  ; HEX VALUE IS 1AB2 | 34CD H =  c | d
   DENOM DD 7219272  ; HEX VALUE IS 006E | 2848 H  =  a | b
                      ; ANSWER IS Q = 62 (3E H), R= 291677 (4735D H)

   ; ----- DEFINE STRINGS AND MEMORY LOCATIONS TO PRINT RESULTS OUT ------- 
   STRING_1 DB 'THE QUOTIENT IS : $'   ; 
   STORE_Q DW ?                      ;  QUOTIENT IS STORED HERE
   STRING_2 DB CR, LF, 'THE REMAINDER IS : $'
   STORE_R DD ?                      ; REMAINDER IS STORED HERE
   STRING_3 DB CR, LF, 'HIT ANY KEY TO QUIT $'
   ;----------------------------------------------------------

DTSEG 	ENDS


;----------CONSTRUCT THE MAIN CODE SEGMENT--------
CDSEG 	SEGMENT
MAIN	PROC FAR  ; This is the program entry point for DOS
        ASSUME CS:CDSEG, DS:DTSEG, SS:STSEG ; INIT THE SEGMENT REGISTERS

        MOV AX,DTSEG  ; INITIALIZE THE DATA 
        MOV DS,AX     ; NEED THIS - ASSUME DS:DTSEG IS UNPREDICTABLE
                      ; IF USING ES THEN ASSUME ES:ESSEG IS UNPREDICTABLE

        ; ------START OF 32-BIT DIV CODE ------------
        
        MOV DX,0    ;Prepare the DX Register for Word/Word Division
                    ;DX Register must be zero, and AX must contain the word size numerator for DIV to work
        MOV AX, WORD PTR NUMER+2 ;1AB2H is in AX
        DIV WORD PTR DENOM+2 ;Dividing 1AB2 H with 006E H
                             ;AX constains q
                             ;and DX contains r
        MOV STORE_Q, AX ;Store the q somewhere
        MOV WORD PTR STORE_R, DX ;Store the r somewhere

        ;NEED TO CALCULATE qb
        MOV DX,0  ;Prepare the DX Register for word*word Multiplication
                             ; DX register must be zero and AX must contain one of the word size operand 
        MOV AX, STORE_Q ;Place q in AX
        MUL WORD PTR DENOM ;Multiply q with b
                           ;Now DX | AX  contains qb which is a double word
                           ;The higher 16 bit digits of qb is in DX and the lower 16 bits is in AX 


        ; CALCULATE qb - d - r*2^16 ; Note that  DX | AX = qb is a double word while d is a word 
        SUB AX, WORD PTR NUMER ; AX = LOW_WORD(qb)  - d 
        SBB DX, WORD PTR STORE_R ; DX = HIGH_WORD(qb) - r - CF (BORROW IN)
                                 ; DX | AX =  qb - d - r*2^16  =  -r'
        JBE CONT ; get out if DX is negative 
        ; OTHERWISE PREPARE FOR ITERATIVE SUBSTRACT
AGAIN:  
        MOV CX, WORD PTR STORE_Q ; We decrement q first
        DEC CX
        MOV STORE_Q, CX ; Store q back for safety

        ; WE NEED TO MINUS a*2^16 + b from DX:AX = -r'
        SUB AX, WORD PTR DENOM ; AX = LOW_WORD(-r') - b
        SBB DX, WORD PTR DENOM+2 ; DX = HIGH_WORD(-r') - a - CF (BORROW IN)
                                 ; Now DX | AX = -r' - a*2^16 - b
        JA AGAIN    ; If DX | AX is still positive, have to do iterative substract again

  CONT: 
        NOT AX  ; DX | AX is negative - so we have to undo the 2'S complement
        NOT DX
        ADD AX, 1  
        ADC DX, 0 ; DX | AX holds the r' that we want

        ;---END OF 32-BIT DIV CODING----------

        ; Store the r' away
        MOV WORD PTR STORE_R, AX
        MOV WORD PTR STORE_R+2, DX

        ; PRINT THE ANSWER 
        SHOW STRING_1 ; SHOW IS A MACRO FROM KB21H.MAC
        DISPLAY_HEX STORE_Q, 2
        SHOW STRING_2  ; The Remainder is ...
        DISPLAY_HEX STORE_R, 4 
        SHOW STRING_3  ; HIT a key to exit
        KEYPRESS ;   KEYPRESS IS A MACRO FROM KB16H.MAC

        MOV AH,4CH  ;  PREPARE TO EXIT TO DOS
        INT 21H
MAIN	ENDP

;---------------------------	

CDSEG	ENDS
	END MAIN	; THIS IS THE EXIT POINT



