PAGE 60,132  ; STATE THE ROW AND COLUMN FORMAT FOR LISTING FILE

TITLE ***PROGRAM TO DO INSERTION SORT***  ; PRINTS OUT TITLE FOR YOUR LISTING 

;-------------CONTRUCTING A STACK SEGMENT----------------

STSEG   SEGMENT STACK 'STACK'
        DB 64 DUP(?)     ; RESERVE 64-BYTES FOR STACK
STSEG 	ENDS

;--------------CONSTRUCTING A DATA SEGMENT---------------- 
                            
DTSEG   SEGMENT  ; DEFINE CONSTANTS (NO MEMORY REQUIRED)

   CR EQU 0DH ; DEFINING CR AS CARRIAGE RETURN CHARACTER
   LF EQU 0AH ; DEFINING LF AS LINE FEED CHARACTER
   LEN EQU 07H

   ; -----DEFINE MEMORY LOCATIONS TO STORE THE LIST OF WORDS TO SORT -----
   LIST_OF_WORDS DW 0A000H, 0B000H, 8000H, 0C000H, 5000H, 2000H, 1000H    
             
   ; ----- DEFINE STRINGS AND MEMORY LOCATIONS TO PRINT RESULTS OUT ----- 
   STRING_1 DB 'THE ORIGINAL LIST IS : $'   ; 
   STRING_2 DB CR, LF, 'THE SORTED LIST IS : $'
   SEPERATOR DB ', $' ; USE FOR SEPARATING THE LIST OF WORDS
   STRING_3 DB CR, LF, 'HIT ANY KEY TO EXIT $'
   ;----------------------------------------------------------
DTSEG 	ENDS

;-----------------CONSTRUCT THE MAIN CODE SEGMENT--------
CDSEG 	SEGMENT
MAIN	PROC FAR  ; This is the program entry point for DOS
        ASSUME CS:CDSEG, DS:DTSEG, SS:STSEG ; INIT THE SEGMENT REGISTERS
	MOV AX,DTSEG
        MOV DS,AX     ; NEED THIS - ASSUME DS:DTSEG IS UNPREDICTABLE
                      ; IF USING ES THEN ASSUME ES:ESSEG IS UNPREDICTABLE

        ;------ Displaying the Original List -------
        MOV DX, OFFSET STRING_1
        CALL SHOW
        MOV CX, LEN   
        MOV SI, OFFSET BYTE PTR LIST_OF_WORDS
        CALL PRINT_LIST

         ; --------START OF INSERTION SORT CODING -------------
         MOV CX,LEN
         MOV BX, OFFSET LIST_OF_WORDS
         MOV SI, OFFSET LIST_OF_WORDS
         MOV DI , OFFSET LIST_OF_WORDS-2
CP_AGN:  CMP DI, OFFSET LIST_OF_WORDS ; MAKE SURE DI DOES NOT GO BEYOND FIRST WORD
         JL GO_TO_NEXT ; JB DOES NOT WORK FOR ADDRESS COMPARISON 
         MOV AX, WORD PTR [SI]
         CMP AX, WORD PTR [DI]
         JA GO_TO_NEXT ; CAN USE JG IF SIGNED WORDS ARE CONSIDERED 
         XCHG AX, WORD PTR [DI]
         XCHG AX, WORD PTR [SI]
         SUB DI, 2
         SUB SI, 2
         JMP CP_AGN
GO_TO_NEXT: MOV DI,BX
         ADD BX,2
         MOV SI,BX
         LOOP CP_AGN
         ;----------END OF INSERTION SORT CODING -------

        ; ----------Displaying the Sorted List ------
        MOV DX, OFFSET STRING_2
        CALL SHOW
        MOV CX, LEN
        MOV SI, OFFSET BYTE PTR LIST_OF_WORDS
        CALL PRINT_LIST
        MOV DX, OFFSET STRING_3
        CALL SHOW ; HIT a key to exit
        CALL KEYPRESS ;

        MOV AH,4CH  ;  PREPARE TO EXIT TO DOS
        INT 21H
MAIN	ENDP

;------------------------------
PRINT_LIST PROC
PGN:    PUSH CX ; STORE COUNTER IN STACK, DISP_HEX MODIFIES CX
        INC SI
        CALL DISP_HEX
        DEC SI
        CALL DISP_HEX
        ADD SI, 2
        MOV DX, OFFSET SEPERATOR
        CALL SHOW
        POP CX
        LOOP PGN
        RET
PRINT_LIST  ENDP

;---------------------------
DISP_HEX PROC
         MOV AL, BYTE PTR [SI]
         MOV AH, AL
         AND AL, 0FH
         MOV CL, 4
         SHR AH, CL
         PUSH AX ; SAVE IT IN STACK
  ; PRINT OUT AH FIRST
         CMP AH, 09H
         JA AH37
         ADD AH, 30H
         JMP SHORT AHINT
 AH37:   ADD AH, 37H
 AHINT:  MOV DL, AH;  SET THE CHAR TO BE DISPLAYED
         MOV AH,02 ;
         INT 21H;
   ; NOW PRINT OUT AL
         POP AX ; READY TO DO AL
         CMP AL, 09H
         JA AL37
         ADD AL, 30H
         JMP SHORT ALINT
 AL37:   ADD AL, 37H
 ALINT:  MOV DL, AL;  SET THE CHAR TO BE DISPLAYED
         MOV AH,02
         INT 21H
         RET
DISP_HEX ENDP
;-----------------------------------
KEYPRESS PROC
KLP_1:  MOV AH, 01 ; CHECK KEYPRESSED
        INT 16H
        JZ KLP_1 ;
        RET
KEYPRESS ENDP
;-----------------------------------
SHOW    PROC 
        MOV AH,09H
        INT 21H
        RET
SHOW    ENDP
;-----------------------------------

CDSEG	ENDS
	END MAIN	; THIS IS THE EXIT POINT



