PAGE 60,132  ; STATE THE ROW AND COLUMN FORMAT FOR LISTING FILE

TITLE ***PROGRAM TO TEST STATUS & BRANCH TO ROUTINES***  ; PRINTS OUT TITLE FOR YOUR LISTING 

;-------CONSTRUCT A STACK SEGMENT----------------

STSEG   SEGMENT STACK 'STACK'
        DB 64 DUP(?)     ; RESERVE 64-BYTES FOR STACK
STSEG 	ENDS

;-------CONSTRUCT A DATA SEGMENT--------------- 

DTSEG   SEGMENT  ; DEFINING CONSTANTS (NO MEMORY REQUIRED)

   CR EQU 0DH ; DEFINING CR AS CARRIAGE RETURN CHARACTER
   LF EQU 0AH ; DEFINING LF AS LINE FEED CHARACTER

   ; ----- DEFINE MEMORY LOCATION TO HOLD STATUS BYTE -----
   STATUS DB 11110101B           

   ; ----- DEFINE STRINGS AND MEMORY LOCATIONS TO PRINT RESULTS OUT -------
   STRING_1 DB CR, LF, 'IN ROUTINE 1 : $'
   STRING_2 DB CR, LF, 'IN ROUTINE 2 : $'
   STRING_3 DB CR, LF, 'IN ROUTINE 3 : $'
   STRING_4 DB CR, LF, 'IN ROUTINE 4 : $'
   STRING_5 DB CR, LF, 'HIT ANY KEY TO EXIT $'
   ;----------------------------------------------------------
DTSEG 	ENDS

;--------CONSTRUCT A SEGMENT FOR ROUTINE 1------------------
R1SEG   SEGMENT
ROUTINE_1 PROC FAR
        PUSH AX
        MOV DX, OFFSET STRING_1
        MOV AH,09H
        INT 21H
        POP AX
        RETF
ROUTINE_1  ENDP
R1SEG   ENDS

;--------CONSTRUCT A SEGMENT FOR ROUTINE 2------------------
R2SEG   SEGMENT
ROUTINE_2 PROC FAR
        PUSH AX
        MOV DX, OFFSET STRING_2
        MOV AH,09H
        INT 21H
        POP AX
        RETF
ROUTINE_2  ENDP
R2SEG   ENDS

;--------CONSTRUCT A SEGMENT FOR ROUTINE 3------------------
R3SEG   SEGMENT
ROUTINE_3 PROC FAR
        PUSH AX
        MOV DX, OFFSET STRING_3
        MOV AH,09H
        INT 21H
        POP AX
        RETF
ROUTINE_3  ENDP
R3SEG   ENDS


;--------CONSTRUCT A SEGMENT FOR ROUTINE 4------------------
R4SEG   SEGMENT
ROUTINE_4 PROC FAR
        PUSH AX
        MOV DX, OFFSET STRING_4
        MOV AH,09H
        INT 21H
        POP AX
        RETF
ROUTINE_4  ENDP
R4SEG   ENDS


;-------CONSTRUCT THE MAIN CODE SEGMENT--------
CDSEG 	SEGMENT
MAIN	PROC FAR  ; This is the program entry point for DOS
        ASSUME CS:CDSEG, DS:DTSEG, SS:STSEG ; INIT THE SEGMENT REGISTERS
	MOV AX,DTSEG
        MOV DS,AX     ; NEED THIS - ASSUME DS:DTSEG IS UNPREDICTABLE
                      ; IF USING ES THEN ASSUME ES:ESSEG IS UNPREDICTABLE

       ; ----CODING TO TEST STATUS AND BRANCH TO FAR ROUTINES----------
                MOV AL, STATUS ;
                TEST AL, 00010101B ; TESTS BITS 0,2,4 FOR 1
                JZ SKIP_1
                CALL ROUTINE_1
       SKIP_1:  TEST AL, 00001010B  ; TEST BITS 1 AND 3
                JNZ SKIP_3
                CALL ROUTINE_3 ;
       SKIP_3:  NOT AL
                TEST AL, 00001010B ;
                JNZ SKIP_2
                CALL ROUTINE_2 ;
       SKIP_2:  CALL ROUTINE_4 ;
       ; ----END OF CODING TO TEST STATUS AND BRANCH TO FAR ROUTINES ----

       MOV DX, OFFSET STRING_5
       CALL SHOW ; HIT a key to exit
       CALL KEYPRESS ;

;-------------------- END PROGRAM CODE --------------------

        MOV AH,4CH  ;  PREPARE TO EXIT TO DOS
        INT 21H
MAIN	ENDP
;-----------------------------------
KEYPRESS PROC
KLP_1:  MOV AH, 01 ; CHECK KEYPRESSED
        INT 16H
        JZ KLP_1 ;
        RET
KEYPRESS ENDP
;-----------------------------------
SHOW    PROC 
        MOV AH,09H
        INT 21H
        RET
SHOW    ENDP
;-----------------------------------

CDSEG	ENDS

        END MAIN        ; THIS IS THE EXIT POINT









